/*
 * @Descripttion: 
 * @version: 
 * @Author: guanxiaoxin
 * @Date: 2023-10-23 13:19:37
 * @LastEditors: guanxiaoxin
 * @LastEditTime: 2023-10-24 09:37:36
 * @FilePath: \VNoteApp\lib\pages\medical\devices\controllers\temp.dart
 */
import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:vnote_device_plugin/devices/temp.dart';
import 'package:vnoteapp/pages/medical/devices/interfaces/device_controller.dart';
import 'package:vnoteapp/pages/medical/models/item.dart';
import 'package:vnoteapp/pages/medical/models/worker.dart';

class TempController extends GetxController implements IDeviceController {
  TempController({
    required this.medicalItem,
    required this.deviceChange,
  });
  MedicalItem medicalItem;
  ValueChanged deviceChange;
  final TempDeviceWorker worker = TempDeviceWorker(
    mac: 'D0:05:00:00:00:67',
    model: 'YHW-6',
  );

  /// 连接设备
  @override
  Future<void> connectDevice() async {
    await worker.connect();
  }

  @override
  void workerAddListener() async {
    worker.successEvent.addListener(_onSuccess);
    worker.connectErrorEvent.addListener(_onConnectFail);
    worker.connectedEvent.addListener(_onConnectSuccess);
    worker.disconnectedEvent.addListener(_onDisconnected);
  }

  @override
  void onInit() {
    connectDevice();
    workerAddListener();
    super.onInit();
  }

  @override
  void onClose() {
    disConnectDevice();
    super.onClose();
  }

  void _onSuccess(_, double e) {
    medicalItem.diagnosisWorkerStatus = WorkerStatus.connected;
    medicalItem.diagnosisData = jsonEncode({'Temperature': e});
    deviceChange.call(medicalItem);
  }

  void _onConnectFail(sender, e) {
    medicalItem.diagnosisWorkerStatus = WorkerStatus.connectionFailed;
    deviceChange.call(medicalItem);
    connectDevice();
  }

  void _onConnectSuccess(sender, e) {}

  void _onDisconnected(sender, e) {
    medicalItem.diagnosisWorkerStatus = WorkerStatus.disconnected;
    deviceChange.call(medicalItem);
    connectDevice();
  }

  @override
  Future<void> disConnectDevice() async {
    worker.connectErrorEvent.removeListener(_onConnectFail);
    worker.connectedEvent.removeListener(_onConnectSuccess);
    worker.successEvent.removeListener(_onSuccess);
    worker.disconnectedEvent.removeListener(_onDisconnected);
    await worker.disconnect();
  }
}
